package kcg.faics.report.service.impl;

import java.util.HashMap;
import java.util.List;

import kcg.faics.report.vo.ReportGoalVO;
import kcg.faics.report.vo.ReportSearchVO;
import kcg.faics.report.vo.ReportVO;
import kcg.faics.sec.LoginUserVO;

import org.springframework.stereotype.Repository;

import egovframework.rte.psl.dataaccess.EgovAbstractMapper;


/**
 * 견문 보고.
 * @author 하영지
 * @since 2016. 10. 5.
 */
@Repository("reportMapper")
public class ReportMapper extends EgovAbstractMapper {

	/**
	 * 견문 정보를 반환한다.
	 * 
	 * @param reportVO 견문vo
	 *            
	 * @return 견문VO
	 * @throws Exception 기본 예외 처리
	 */
	public ReportVO select(final ReportVO reportVO) throws Exception {
		return selectOne("Report.select", reportVO);
	}

	/**
	 * 페이징 처리 없이 견문 전체 목록을 반환한다.
	 * 
	 * @param reportSearchVO
	 *            검색정보 객체
	 * @return 견문 목록
	 * @throws Exception 기본 예외 처리
	 */
	public List<ReportVO> selectListAll(final ReportSearchVO reportSearchVO) throws Exception {
		return selectList("Report.selectListAll", reportSearchVO);
	}

	/**
	 * 견문정보 총 개수를 반환한다.
	 * 
	 * @param reportSearchVO
	 *            검색, 페이지정보 객체
	 * @return 견문정보 총 개수
	 * @throws Exception
	 *             기본 예외 처리
	 */
	public int selectTotalCnt(final ReportSearchVO reportSearchVO) throws Exception {
		return (Integer) selectOne("Report.selectTotalCnt", reportSearchVO);
	}

	/**
	 * 견문 목록를 반환한다.
	 * 
	 * @param reportSearchVO
	 *            검색, 페이지정보 객체
	 * @return 견문 목록
	 * @throws Exception
	 *             기본 예외 처리
	 */
	public List<ReportVO> selectList(final ReportSearchVO reportSearchVO) throws Exception {
		return selectList("Report.selectList", reportSearchVO);
	}

	/**
	 * 견문 목록 개수를 반환한다.
	 * 
	 * @param reportSearchVO
	 *            검색, 페이지정보 객체
	 * @return 견문 목록 개수
	 * @throws Exception
	 *             기본 예외 처리
	 */
	public int selectListCnt(final ReportSearchVO reportSearchVO) throws Exception {
		return (Integer) selectOne("Report.selectListCnt", reportSearchVO);
	}

	/**
	 * 견문 정보를 입력한다.
	 * 
	 * @param reportVO 견문 VO
	 * @return 맵 객체 {result: 성공여부, seq: 입력된 레코드의 key 값}
	 * @throws Exception 기본 예외 처리
	 */
	public HashMap<String, Object> insert(final ReportVO reportVO) throws Exception {
		HashMap<String, Object> map = new HashMap<String, Object>();

		int result = 0;
		try {
			result = insert("Report.insert", reportVO);

			map.put("result", result);
			map.put("seq", reportVO.getInSeq());
		} catch (Exception e) {
			e.printStackTrace();
		}
		return map;
	}

	/**
	 * 견문 정보를 갱신한다.
	 * 
	 * @param reportVO
	 *            견문 VO
	 * @return 성공 - 1, 실패 - 0
	 * @throws Exception
	 *             기본 예외 처리
	 */
	public int update(final ReportVO reportVO) throws Exception {
		return update("Report.update", reportVO);
	}

	/**
	 * 견문 정보를 삭제한다.
	 * 
	 * @param reportVO
	 *            견문 VO
	 * @return 성공 - 1, 실패 - 0
	 * @throws Exception
	 *             기본 예외 처리
	 */
	public int delete(final ReportVO reportVO) throws Exception {
		return delete("Report.delete", reportVO);
	}
	
	/**
	 * 견문의 새 소속번호를 반환한다.
	 * 
	 * @param reportVO 견문vo
	 * @return 새 소속번호
	 * @throws Exception 기본예외처리
	 */
	public int selectPlaceNum(final ReportVO reportVO) {
		return selectOne("Report.selectPlaceNum", reportVO);
	}
	
	/**
	 * 견문의 임시저장목록을 반환한다.
	 * 
	 * @param reportSearchVO 견문 검색조건 vo
	 * @return 견문 임시저장목록
	 */
	public List<ReportVO> selectSaveList(final ReportSearchVO reportSearchVO) {
		return selectList("Report.selectSaveList", reportSearchVO);
	}
	/**
	 * 견문의 임시저장목록 결과 갯수를 반환한다.
	 * 
	 * @param reportSearchVO 견문 검색조건 vo
	 * @return 견문 임시저장목록 결과 갯수
	 */
	public int selectSaveListCnt(final ReportSearchVO reportSearchVO) {
		return selectOne("Report.selectSaveListCnt", reportSearchVO);
	}
	
	/**
	 * 견문의 자동삭제목록을 반환한다.
	 * 
	 * @return 견문 임시저장목록
	 */
	public String selectAutoRemoveList() {
		return selectOne("Report.selectAutoRemoveList");
	}

	/**
	 * 견문제출현황을 반환한다.
	 * 
	 * @param reportSearchVO 견문 검색 객체
	 * @return 견문제출현황 목록
	 * @throws Exception 기본 예외 처리
	 */
	public List<ReportVO> selectPresentList(final ReportSearchVO reportSearchVO) throws Exception {
		return selectList("Report.selectPresentList", reportSearchVO);
	}
	
	/**
	 * 견문제출현황 갯수를 반환한다.
	 * 
	 * @param reportSearchVO 견문 검색 객체
	 * @return 견문제출현황 목록 갯수
	 * @throws Exception 기본 예외 처리
	 */
	public int selectPresentListCnt(final ReportSearchVO reportSearchVO) throws Exception {
		return selectOne("Report.selectPresentListCnt", reportSearchVO);
	}
	
	/**
	 * 견문제출현황 전체목록을 반환한다.
	 * 
	 * @param reportSearchVO 견문 검색 객체
	 * @return 견문제출현황 전체 목록
	 * @throws Exception 기본 예외 처리
	 */
	public List<ReportVO> selectPresentListAll(final ReportSearchVO reportSearchVO) throws Exception {
		return selectList("Report.selectPresentListAll", reportSearchVO);
	}

	/**
	 * 평가기록부을 반환한다.
	 * 
	 * @param reportSearchVO 견문 검색 객체
	 * @return 견문제출현황 목록
	 * @throws Exception 기본 예외 처리
	 */
	public List<ReportVO> selectRecordList(final ReportSearchVO reportSearchVO) throws Exception {
		return selectList("Report.selectRecordList", reportSearchVO);
	}
	
	/**
	 * 평가기록부 갯수를 반환한다.
	 * 
	 * @param reportSearchVO 견문 검색 객체
	 * @return 평가기록부 목록 갯수
	 * @throws Exception 기본 예외 처리
	 */
	public int selectRecordListCnt(final ReportSearchVO reportSearchVO) throws Exception {
		return selectOne("Report.selectRecordListCnt", reportSearchVO);
	}
	
	/**
	 * 평가기록부 전체목록을 반환한다.
	 * 
	 * @param reportSearchVO 견문 검색 객체
	 * @return 평가기록부 전체 목록
	 * @throws Exception 기본 예외 처리
	 */
	public List<ReportVO> selectRecordListAll(final ReportSearchVO reportSearchVO) throws Exception {
		return selectList("Report.selectRecordListAll", reportSearchVO);
	}

	/**
	 * 목표 관리 목록을 반환한다.
	 * 
	 * @param reportSearchVO 견문 검색 객체
	 * @return 목표 관리 
	 * @throws Exception 기본예외처리
	 */
	public List<ReportGoalVO> selectGoalList(final ReportSearchVO reportSearchVO) throws Exception {
		return selectList("ReportGoal.selectList", reportSearchVO);
	}
	
	/**
	 * 목표 레코드 1개를 조회한다.
	 * 
	 * @param reportGoalVO 견문 검색 객체
	 * @return 목표 레코드
	 * @throws Exception 기본예외처리
	 */
	public ReportGoalVO selectGoal(final ReportGoalVO reportGoalVO) throws Exception {
		return selectOne("ReportGoal.select", reportGoalVO);
	}

	/**
	 * 목표를 입력한다.
	 * 
	 * @param reportGoalVO 견문 검색 객체
	 * @return 목표 레코드
	 * @throws Exception 기본예외처리
	 */
	public int insertGoal(final ReportGoalVO reportGoalVO) throws Exception {
		return insert("ReportGoal.insert", reportGoalVO); 
	}
	/**
	 * 목표를 수정한다.
	 * 
	 * @param reportGoalVO 견문 검색 객체
	 * @return 목표 레코드
	 * @throws Exception 기본예외처리
	 */
	public int updateGoal(final ReportGoalVO reportGoalVO) throws Exception {
		return update("ReportGoal.update", reportGoalVO);
	}
	
	/**
	 * 사용자별 목표 통계를 반환한다.
	 * 
	 * @param reportSearchVO 견문 검색객체
	 * @return 목표 통계
	 * @throws Exception 기본예외처리
	 */
	public List<HashMap<String, Object>> getGoalStats(final ReportSearchVO reportSearchVO) throws Exception {
		return selectList("ReportGoal.getStats", reportSearchVO);
	}

	/**
	 * 소속별 목표 통계를 반환한다.
	 * 
	 * @param reportSearchVO 견문 검색객체
	 * @return 목표 통계
	 * @throws Exception 기본예외처리
	 */
	public List<HashMap<String, Object>> getGoalStatsPlace(final ReportSearchVO reportSearchVO) throws Exception {
		return selectList("ReportGoal.getStatsPlace", reportSearchVO);
	}
}
